{

  (*
    This file is part of Mymms.
    
    Mymms is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    
    Mymms is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with Mymms.  If not, see <http://www.gnu.org/licenses/>.
    
    Copyright (C) 2008 Nicolas Marti
  *)


  open Parser;;

}

let digit = ['0'-'9']
let name = ['A'-'Z' 'a'-'z' '0'-'9']+
  rule token = parse
    | [' ' '\t' '\n' '\r']+ { token lexbuf }

    | "_" { UNDERSCORE }

    | "\\" { LAMBDA }
    | '!' { PHI }
    | 'I' { IND }
    | 'V' { FORALL }

    | "match" { MATCH }
    | "return" { RETURN }
    | "with" { WITH }
    | "Type" { TYPE }
    | "cons" { CONS }
    | "of" { OF }

    | '(' { LPAREN }
    | ')' { RPAREN }

    | '[' { LBRACK }
    | ']' { RBRACK }

    | '{' { LACCOL }
    | '}' { RACCOL }
       
    | ',' { COMMA }
    | ';' { SCOMMA }

    | '=' { EQ }
    | ':' { DDOT }
    | "|-" { TURNSTIL }
    | '.' { DOT }
    | '|' { PAR } 

    | "->" { IMPL }

    | "@" { AROBAS }

    | "Alpha" { ALPHA } 
    | "Typecheck" { TYPECHECK }
    | "Simpl" { SIMPL }
    | "Quit" { QUIT }
    | "Show Definitions" { SHOWDEF }
    | "Show Coercions" { SHOWCOERCION }
    | "Undo" { UNDO }

    | "Inductive" { INDUCTIVE }
    | "Recursive" { RECURSIVE }
    | "Definition" { DEFINITION }
    | "Coercion" { COERCION }
    | "Overload" { OVERLOAD }
    | "Implicite" { IMPLICITE }

    | digit+ as num { NUM (int_of_string num) }
    | name as word { NAME word }
        
    | eof { EOF }

