(*
  This file is part of Mymms.

  Mymms is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Mymms is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Mymms.  If not, see <http://www.gnu.org/licenses/>.

  Copyright (C) 2008 Nicolas Marti
*)

open List;;


let rec nth_head n l =
  match n with
    | 0 -> []
    | j ->
        match l with
          | [] -> []
          | hd :: tl ->
              hd :: (nth_head (j-1) tl)
;;

let rec nth_tail n l =
  match n with
    | 0 -> l
    | j ->
        match l with
          | [] -> []
          | hd :: tl ->
              nth_tail (j-1) tl
;;

let rec remove_indices' l ind ci =
  match ind with
    | [] -> l
    | hdi :: tli ->
        if (hdi = ci) then (
          match l with
            | [] -> []
            | hd :: tl -> remove_indices' tl tli (ci+1)
        ) else (
          match l with
            | [] -> []
            | hd :: tl -> hd :: remove_indices' tl ind (ci+1)
        )
;;

let remove_indices l ind = 
  remove_indices' l ind 0
;;

let rec list_proj1 l =
  match l with
    | [] -> []
    | (hd1, hd2) :: tl ->
        hd1 :: (list_proj1 tl)
;;

let rec list_proj2 l =
  match l with
    | [] -> []
    | (hd1, hd2) :: tl ->
        hd2 :: (list_proj2 tl)
;;

let rec find_list l n =
  match l with 
    | [] -> None
    | (hd1, hd2) :: tl ->
        if (hd1 = n) then 
          Some (hd2)
        else
          find_list tl n
;;

let rec list_of_n_elt e n =
  match n with
    | 0 -> []
    | n -> (e :: (list_of_n_elt e (n - 1)))
;;

let rec list2listoption l =
  match l with
    | [] -> []
    | hd :: tl ->
        (Some hd) :: (list2listoption tl)
;;
