(*
  This file is part of Mymms.

  Mymms is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Mymms is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Mymms.  If not, see <http://www.gnu.org/licenses/>.

  Copyright (C) 2008 Nicolas Marti
*)

open Printf;;

let rec interactive () =
  try 
    let lexbuf = (Lexing.from_channel stdin) in
      while true do 
        printf "Kernel < "; flush stdout;
        Parser.command Lexer.token lexbuf
      done
  with 
      _ -> printf "Error: parsing error!\n\n"; flush stdout; interactive ();
          
  ;;

let main () =

  let filename = try Sys.argv.(1) with
      Invalid_argument _ -> (interactive ()); exit 0
  in
  let filechannel = open_in filename in
  let lexbuf = Lexing.from_channel filechannel in
    try 
      Parser.input Lexer.token lexbuf
    with
        Parsing.Parse_error -> printf "parsing error\n"; exit 0
;;

main ();;

