(*
  This file is part of Mymms.

  Mymms is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Mymms is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Mymms.  If not, see <http://www.gnu.org/licenses/>.

  Copyright (C) 2008 Nicolas Marti
*)

open Varset;;
open Varmap;;
open Def;;

type int_state = {
  mutable def: definition; 
  mutable coercion: (term * term * int) list;
  mutable oracles:  (context -> term -> definition -> term) list;
  mutable overload: ((term * int) list) VarMap.t;
  mutable implicite: int VarMap.t;
};;

let state : int_state = {
  def = VarMap.empty; 
  coercion = [];
  oracles = [];
  overload = VarMap.empty;
  implicite = VarMap.empty;
};;


let add_overload name te nbimplicite =
          try (

            let l = VarMap.find name state.overload in

              state.overload <- VarMap.add name ((te, nbimplicite)::l) (VarMap.remove name state.overload);

          ) with
            | _ -> 
                state.overload <- VarMap.add name ((te, nbimplicite)::[]) state.overload
;;

let add_implicite name nbimplicite =
    try (
      
      let _ = VarMap.find name state.implicite in
        
        ()
          
          
    ) with
      | _ -> 
          state.implicite <- VarMap.add name nbimplicite state.implicite
;;

let add_coercion te ty nbimplicite = 

  state.coercion <- (te, ty, nbimplicite)::state.coercion;



